#include <stdio.h>
#include <stdlib.h>

void boje( int *tabela[][], int x, int y, int *br)
{
        *tabela[x][y]=*br;
        if(*tabela[x][y+1]==0)
            boje(&tabela,x,y+1,&br);
        if(*tabela[x+1][y]==0)
            boje(&tabela,x+1,y,&br);
        if(*tabela[x-1][y]==0)
            boje(&tabela,x-1,y,&br);
        if(*tabela[x][y-1]==0)
            boje(&tabela,x,y-1,&br);
        br++;
}

int main()
{
    int i,x,y,n,m,k,j,br=2;
    scanf("%d%d%d",&n,&m,&k);
    int tabla[n+1][m+1];
    for(i=0;i<n+1;i++)
        for(j=0;j<m+1;j++)
            tabla[i][j]=0;
    for(i=0;i<k;i++)
    {
        scanf("%d %d",&x,&y);
        tabla[x][y]=1;
    }
    for(i=0;i<n;i++)
        for(j=0;j<m;j++)
            if(tabla[i][j]==0)
                boje(&tabela,i,j,&br);
        printf("%d",br-3);
}